import { LogLevel } from './internalTypes';
export type Message = {
    type: string;
    data?: object;
};
export type DevtoolsMessage = {
    type: string;
    appName: string;
    data: any;
};
export declare class Devtools {
    private logLevel;
    private safeClassNames;
    private unsafeClassNames;
    private circularReferenceCache;
    private buffer;
    private serializer;
    private ws;
    private isConnected;
    private doReconnect;
    private hasWarnedReconnect;
    private reconnectInterval;
    private name;
    constructor(name: string, logLevel?: LogLevel);
    connect: (host: string, onMessage: (message: Message) => void) => void;
    private reconnect;
    send(message: Message): void;
    private sendMessage;
    private flushBuffer;
}
